> ## Documentation Index
> Fetch the complete documentation index at: https://docs.firedrill.run/llms.txt
> Use this file to discover all available pages before exploring further.

# List explicit project grants



## OpenAPI

````yaml /api-reference/openapi.json get /v1/projects/{projectId}/grants
openapi: 3.1.0
info:
  title: Firedrill Control API
  version: 1.0.0
  description: >-
    The control plane for drills, drill runs, and the worlds they run in. Errors
    always carry the canonical envelope; unsafe operations require an
    Idempotency-Key; long work returns an operation resource.
servers:
  - url: https://api.firedrill.run
security:
  - controlCredential: []
paths:
  /v1/projects/{projectId}/grants:
    get:
      summary: List explicit project grants
      operationId: projects.listGrants
      parameters:
        - name: projectId
          in: path
          required: true
          schema:
            type: string
            pattern: ^prj_[0-9a-z]{12,32}$
      responses:
        '200':
          description: Project grants
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectGrantPage'
        default:
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
components:
  schemas:
    ProjectGrantPage:
      type: object
      properties:
        items:
          maxItems: 10000
          type: array
          items:
            type: object
            properties:
              schemaVersion:
                type: number
                enum:
                  - 1
              grantId:
                type: string
                pattern: ^grant_[0-9a-z]{12,32}$
              organizationId:
                type: string
                pattern: ^org_[0-9a-z]{12,32}$
              projectId:
                type: string
                pattern: ^prj_[0-9a-z]{12,32}$
              subjectId:
                type: string
                pattern: ^usr_[0-9a-z]{12,32}$
              role:
                type: string
                enum:
                  - viewer
                  - builder
                  - manager
              actions:
                minItems: 1
                maxItems: 45
                type: array
                items:
                  type: string
                  enum:
                    - profile.read
                    - profile.manage
                    - organization.read
                    - organization.manage
                    - organization.billing.read
                    - organization.billing.manage
                    - organization.audit.read
                    - organization.evidence.export
                    - organization.members.manage
                    - project.create
                    - project.read
                    - project.manage
                    - project.members.manage
                    - repository.read
                    - repository.connect
                    - repository.sync
                    - build.read
                    - build.publish
                    - environment.read
                    - environment.create
                    - environment.promote
                    - environment.archive
                    - session.read
                    - session.create
                    - session.control
                    - session.destroy
                    - drill.read
                    - drill.run
                    - run.read
                    - run.cancel
                    - run.compare
                    - evidence.read
                    - evidence.delete
                    - evidence.share
                    - evidence.export
                    - evidence.upload
                    - credential.manage
                    - tool.read
                    - tool.publish
                    - authoring.read
                    - authoring.run
                    - authoring.publish
                    - ci.execute
                    - demo.read
                    - demo.manage
              createdAtMs:
                type: integer
                minimum: -9007199254740991
                maximum: 9007199254740991
              version:
                type: integer
                minimum: -9007199254740991
                maximum: 9007199254740991
            required:
              - schemaVersion
              - grantId
              - organizationId
              - projectId
              - subjectId
              - role
              - actions
              - createdAtMs
              - version
            additionalProperties: false
      required:
        - items
      additionalProperties: false
    ErrorEnvelope:
      type: object
      properties:
        code:
          type: string
          pattern: ^(control|world)\.[A-Z][A-Z0-9]*(_[A-Z0-9]+)*$
        message:
          type: string
          minLength: 1
        correlationId:
          type: string
          minLength: 1
        retryable:
          type: boolean
        retryAfterMs:
          type: integer
          exclusiveMinimum: 0
          maximum: 9007199254740991
        operationId:
          type: string
        source:
          type: string
          enum:
            - platform
            - simulated_provider
        issues:
          type: array
          items:
            type: object
            properties:
              path:
                type: string
              code:
                type: string
              message:
                type: string
            required:
              - path
              - code
              - message
            additionalProperties: false
        details:
          type: object
          propertyNames:
            type: string
          additionalProperties: {}
        evidence:
          type: object
          properties:
            sessionId:
              type: string
            runId:
              type: string
            journalSeq:
              type: integer
              minimum: 0
              maximum: 9007199254740991
            buildHash:
              type: string
          additionalProperties: false
      required:
        - code
        - message
        - correlationId
        - retryable
        - source
      additionalProperties: true
  securitySchemes:
    controlCredential:
      type: http
      scheme: bearer
      description: Opaque control credential

````